Program N_Vezer{Rekurzv backtrack};
  {
   Az 'N-vezr problma backtrack trsa rekurzvra' feladat.
   -- keretprogram
   (azaz az iteratv vltozat))
  }
  Uses
     Newdelay,Crt,Graph,CursUnit;
  Const
     MaxN  = 10;
  Type
     Index = 0..MaxN+1;
     MIndex= -1..MaxN+1;
     Tabla = Array [1..MaxN] of (Ures,Foglalt);
     Hol   = Array [1..MaxN] of Index;
  Var
     Vezer : Hol;
     i: MIndex;
     N,j,
     hova  : Index;
     lehet : Boolean;
  {$i Vezer.inc}

  {----------------- lnyegi eljrsok --------------------}

  Function Uti(vx1,vy1, vx2,vy2: Index): Boolean;
  Begin
    Uti:=(vy1=vy2) or (Abs(vy1-vy2)=vx1-vx2)
  End; {Uti}

  Function RosszEset(x,y: Index): Boolean;
    Var
       j: Index;
  Begin
    Letesz(x,y,True);
    j:=1;
    While (j<=x-1) and not uti(x,y, j,Vezer[j]) do
    Begin
      Inc(j);
    End;
    Varakozas(1); Folvesz(x,y);
    RosszEset:=j<=x-1
  End;

  Procedure VanJoEset(i: Index; Var talan: Boolean; Var ide: Index);
  Begin
    ide:=Vezer[i]+1;
    While (ide<=N) and RosszEset(i,ide) do Inc(ide);
    talan:=ide<=N;
  End;

  Procedure BackTrack;
  Begin
    i:=1;
    For j:=1 to N do Vezer[j]:=0;
    While i in [1..N] do
    Begin
      Varakozas(2);
      VanJoEset(i,lehet,hova);
      If lehet then
      Begin
        Letesz(i,hova,False); Vezer[i]:=hova; Inc(i);
      End
        else
      Begin
        Vezer[i]:=0; Dec(i);
        If i>0 then
        Begin
          Folvesz(i,Vezer[i]);
        End;
      End;

    End;
    If i>0 then VanMegoldas(N)
           else NincsMegoldas(N);
  End;

Begin
  Inicializalas(N);
  CurOff;
  BackTrack;
  CurOn;
End.
